DECLARE SUB SaveScores ()
DECLARE SUB PlaySound ()
DECLARE SUB OpenScores ()
DECLARE SUB ShowMenu ()
DECLARE SUB ShowScore ()
DECLARE SUB Setup ()
DECLARE SUB Delay ()
DECLARE SUB Die ()
DECLARE SUB DrawScreen ()
DECLARE SUB Raster ()
DECLARE FUNCTION DirOfPart% (Part%)
DECLARE SUB PlaceFruit ()
DECLARE SUB DrawSnake ()
DECLARE SUB MoveSnake ()

'$INCLUDE: 'future.bi'
'$DYNAMIC
DEFINT A-Z
DIM SHARED Image(514), Image2(514), Image3(514), Image4(514), Dir, AutoDir
DIM SHARED Length, Page, Score, Difficulty, Highscore, HighName$
TYPE Parts
  X AS INTEGER
  Y AS INTEGER
END TYPE
DIM SHARED Part(150) AS Parts, Fruit.X, Fruit.Y, NewDir
DIM SHARED Menu, Fruit1(514), Fruit2(514), FruitType

RANDOMIZE TIMER
Setup

PlaceFruit
Future.LoadGIF "menu.gif", 0, 0
Future.EMSGet 0, 0, 100, 480, Menu
Future.GET 100, 1, 115, 16, Image4()
Future.GET 100, 17, 115, 32, Image3()
Future.GET 100, 32, 115, 47, Image2()
Future.GET 100, 49, 115, 64, Image()
Future.GET 100, 65, 115, 80, Fruit1()
Future.GET 100, 80, 115, 95, Fruit2()
Future.CLS 0

FOR P = 0 TO 2
Setpage P
Future.BOX 14, 14, 539, 450, 255
Future.EMSPut 540, 0, Menu
Future.Print 587, 10, "Score:", 255, -1
Future.FillBox 550, 26, 635, 42, 0
Future.BOX 549, 25, 636, 43, 255

Future.Print 587, 50, "Level:", 255, -1
Future.FillBox 550, 66, 635, 82, 0
Future.Print 579, 66, "Level" + STR$(Difficulty), 255, 0
Future.BOX 549, 65, 636, 83, 255

Future.Print 555, 90, "Highscore:", 255, -1
Future.FillBox 550, 106, 635, 122, 0
Future.BOX 549, 105, 636, 123, 255

Points$ = LTRIM$(RTRIM$(STR$(Highscore)))
Future.Print 635 - (LEN(Points$) * 8), 106, Points$, 255, 0

Future.Print 611, 130, "By:", 255, -1
Future.FillBox 550, 146, 635, 162, 0
Future.BOX 549, 145, 636, 163, 255

Points$ = HighName$
Future.Print 635 - (LEN(Points$) * 8), 146, Points$, 255, 0
NEXT
DeallExpMem Menu
SetViewPort 15, 15, 539, 450

Length = 15
FOR Z = 0 TO Length
  Part(Z).X = Z + 15
  Part(Z).Y = 15
  Future.ROTATEB Part(Z).X * 15, Part(Z).Y * 15, 90, 1, Image()
NEXT

SetTIMERspeed 760
SetSubTIMERspeed 76, 1
StartTIMER
StartSubTIMER 1

Dir = 2: NewDir = 2
DO
A$ = INKEY$
IF A$ <> "" THEN P = ASC(RIGHT$(A$, 1))
SELECT CASE P
  CASE 27: EXIT DO
  CASE 72: IF Dir <> 4 THEN NewDir = 1
  CASE 75: IF Dir <> 3 THEN NewDir = 2
  CASE 77: IF Dir <> 2 THEN NewDir = 3
  CASE 80: IF Dir <> 1 THEN NewDir = 4
  CASE 134: Future.SnapShot "shot.bmp"
  END SELECT
  P = 0
Page = Page + 1: IF Page = 3 THEN Page = 0
IF Page = 0 THEN
        IF NewDir <> Dir THEN Dir = NewDir
        MoveSnake
END IF

Setpage Page
DrawSnake
WAIT &H3DA, 8, 8: WAIT &H3DA, 8
ShowScore
Viewpage Page
Delay
LOOP
StopSubTIMER 7
StopAndReset
ReSetScreen

REM $STATIC
SUB Delay
DO
DelayT& = ReadSubCounter&(1)
IF DelayT& >= 7 - (Difficulty / 2) THEN ResetSubCounter 1: EXIT SUB
LOOP
Future.Print 0, 0, STR$(DelayT&), 255, 0
END SUB

SUB Die
IF Score > Highscore THEN
        Position = 15
        Future.FillBox 15, 416, 539, 450, 4
        Future.Print 15, 418, "You've got the Highscore! Enter your name...", 255, 4
        DO: A$ = INKEY$
        IF A$ <> "" THEN
                P = ASC(RIGHT$(A$, 1))
                IF P >= 97 AND P <= 122 OR P >= 65 AND P <= 90 THEN
                        IF LEN(NewName$) < 10 THEN
                        NewName$ = NewName$ + UCASE$(A$)
                        Future.Print Position, 434, UCASE$(A$), 255, 4
                        Position = Position + 8
                        END IF
                END IF
                IF P = 8 THEN
                        NewName$ = LEFT$(NewName$, LEN(NewName$) - 1)
                        Position = Position - 8
                        Future.Print Position, 434, " ", 255, 4
                END IF
        END IF
        LOOP UNTIL A$ = CHR$(13) OR A$ = CHR$(27)
        HighName$ = NewName$
        Highscore = Score
        SaveScores
END IF
Future.Print 15, 15, "Game over...Press ESC to end", 255, -1
StopSubTIMER 7
DO: LOOP UNTIL INKEY$ = CHR$(27)
SetViewPort 0, 0, 640, 480
ReSetScreen
StopAndReset
END
END SUB

REM $DYNAMIC
FUNCTION DirOfPart (Which)
IF Which > Length THEN EXIT FUNCTION
IF Which <= 0 THEN DirOfPart = Dir: EXIT FUNCTION
IF Part(Which - 1).Y < Part(Which).Y THEN DirOfPart = 1: EXIT FUNCTION
IF Part(Which - 1).Y > Part(Which).Y THEN DirOfPart = 4: EXIT FUNCTION
IF Part(Which - 1).X < Part(Which).X THEN DirOfPart = 2: EXIT FUNCTION
IF Part(Which - 1).X > Part(Which).X THEN DirOfPart = 3: EXIT FUNCTION
END FUNCTION

SUB DrawSnake
Future.CLS 0

FOR Z = 1 TO Length
  X1 = Part(Z).X * 15
  Y1 = Part(Z).Y * 15
 
IF X1 > 0 AND Y1 > 0 THEN

  SELECT CASE DirOfPart(Z)
  CASE 1: Y1 = Y1 - Page * 5
  CASE 2: X1 = X1 - Page * 5
  CASE 3: X1 = X1 + Page * 5
  CASE 4: Y1 = Y1 + Page * 5
  END SELECT
  SELECT CASE DirOfPart(Z)
  CASE 1: Future.ROTATEB X1, Y1, 0, 1, Image()
  CASE 2: Future.ROTATEB X1, Y1, 90, 1, Image()
  CASE 3: Future.ROTATEB X1, Y1, 90, 1, Image()
  CASE 4: Future.ROTATEB X1, Y1, 0, 1, Image()
  END SELECT
  Z1 = DirOfPart(Z)
  Z2 = DirOfPart(Z - 1)
  IF Z1 <> Z2 THEN
    '*** Corners in the snake =)
    X1 = Part(Z - 1).X * 15
    Y1 = Part(Z - 1).Y * 15
    IF Z1 = 1 AND Z2 = 3 THEN Future.ROTATEB X1, Y1, 0, 1, Image2()
    IF Z1 = 1 AND Z2 = 2 THEN Future.ROTATEB X1 - 1, Y1, 270, 1, Image2()
    IF Z1 = 2 AND Z2 = 1 THEN Future.ROTATEB X1, Y1, 90, 1, Image2()
    IF Z1 = 2 AND Z2 = 4 THEN Future.FillBox X1, Y1, X1 + 14, Y1 + 15, 0
    IF Z1 = 2 AND Z2 = 4 THEN Future.ROTATEB X1, Y1 + 1, 0, 1, Image2()
    IF Z1 = 3 AND Z2 = 1 THEN Future.ROTATEB X1 - 1, Y1, 180, 1, Image2()
    IF Z1 = 3 AND Z2 = 4 THEN Future.FillBox X1, Y1, X1 + 15, Y1 + 15, 0
    IF Z1 = 3 AND Z2 = 4 THEN Future.ROTATEB X1 - 1, Y1 + 1, 270, 1, Image2()
    IF Z1 = 4 AND Z2 = 3 THEN Future.ROTATEB X1, Y1 - 1, 90, 1, Image2()
    IF Z1 = 4 AND Z2 = 2 THEN Future.ROTATEB X1 - 1, Y1 - 1, 180, 1, Image2()
  END IF
END IF
NEXT Z

'*** Tail of Snake:
IF X1 > 0 AND Y1 > 0 THEN
  SELECT CASE DirOfPart(Length - 1)
  CASE 1: Future.FillBox Part(Length).X * 15, Part(Length).Y * 15, Part(Length).X * 15 + 15, Part(Length).Y * 15 + 15, 0
  Future.ROTATEB X1, Y1, 0, 1, Image3()
  CASE 2: Future.FillBox Part(Length).X * 15, Part(Length).Y * 15, Part(Length).X * 15 + 15, Part(Length).Y * 15 + 15, 0
  Future.ROTATEB X1, Y1, 90, 1, Image3()
  CASE 3: Future.FillBox Part(Length).X * 15, Part(Length).Y * 15, Part(Length).X * 15 + 14, Part(Length).Y * 15 + 15, 0
  Future.ROTATEB X1 - 1, Y1, 270, 1, Image3()
  CASE 4: Future.FillBox Part(Length).X * 15, Part(Length).Y * 15, Part(Length).X * 15 + 15, Part(Length).Y * 15 + 14, 0
  Future.ROTATEB X1, Y1 - 1, 180, 1, Image3()
  END SELECT
END IF


'*** Head of Snake:
X1 = Part(0).X * 15
Y1 = Part(0).Y * 15
  SELECT CASE Dir
  CASE 1: Y1 = Y1 - Page * 5
  CASE 2: X1 = X1 - Page * 5
  CASE 3: X1 = X1 + Page * 5
  CASE 4: Y1 = Y1 + Page * 5
  END SELECT

SetMaskColor 0
  SELECT CASE Dir
  CASE 1: Future.ROTATEB X1, Y1, 0, 1, Image4()
  CASE 2: Future.ROTATEB X1, Y1, 90, 1, Image4()
  CASE 3: Future.ROTATEB X1 - 1, Y1, 270, 1, Image4()
  CASE 4: Future.ROTATEB X1, Y1 - 1, 180, 1, Image4()
  END SELECT
SetMaskColor -1
IF FruitType = 0 THEN
  'Future.BOX Fruit.X * 15, Fruit.Y * 15, Fruit.X * 15 + 14, Fruit.Y * 15 + 14, 255
  Future.PUT Fruit.X * 15, Fruit.Y * 15, Fruit1()
ELSE
  Future.PUT Fruit.X * 15, Fruit.Y * 15, Fruit2()
END IF
END SUB

SUB MoveSnake
FOR Z = Length TO 1 STEP -1
Part(Z).X = Part(Z - 1).X
Part(Z).Y = Part(Z - 1).Y
NEXT
SELECT CASE Dir
CASE 1: Part(Z).Y = Part(Z).Y - 1
CASE 2: Part(Z).X = Part(Z).X - 1
CASE 3: Part(Z).X = Part(Z).X + 1
CASE 4: Part(Z).Y = Part(Z).Y + 1
END SELECT
FOR Z = 1 TO Length
IF Part(Z).X = Part(0).X AND Part(Z).Y = Part(0).Y THEN Die
NEXT
IF Part(0).X = 36 OR Part(0).Y = 30 THEN Die
IF Part(0).X = 0 OR Part(0).Y = 0 THEN Die
IF Part(0).X = Fruit.X AND Part(0).Y = Fruit.Y THEN Length = Length + 1: Score = Score + Difficulty: PlaceFruit: PlaySound
END SUB

REM $STATIC
SUB OpenScores
OPEN "score.dat" FOR INPUT AS #1
INPUT #1, HighName$
INPUT #1, Highscore
CLOSE #1
END SUB

REM $DYNAMIC
SUB PlaceFruit
StartFruit:
Fruit.X = (RND * 33) + 1
Fruit.Y = (RND * 28) + 1

FOR ZZ = 0 TO Length
  IF Part(ZZ).X = Fruit.X AND Part(ZZ).Y = Fruit.Y THEN GOTO StartFruit
NEXT
FruitType = RND * 1
END SUB

REM $STATIC
SUB PlaySound
'Loadwav "fruit.wav",-1
END SUB

REM $DYNAMIC
SUB Raster
FOR A = 0 TO 34
  Future.LINE A * 15, 0, A * 15, 450, 1, -1
NEXT
FOR B = 0 TO 29
  Future.LINE 0, B * 15, 540, B * 15, 1, -1
  Future.Print 15, B * 15, STR$(B), 255, 0
NEXT
END SUB

REM $STATIC
SUB SaveScores
OPEN "score.dat" FOR OUTPUT AS #1
PRINT #1, HighName$
PRINT #1, Highscore
CLOSE #1
END SUB

SUB Setup
IF IsVESA THEN
        Set640x480 8
        Setpage 0
        Viewpage 0
        Future.CLS 0
ELSE
        PRINT "You must have a VESA-compatible videocard to play this game."
        PRINT "Please refer to the documentation!"
        DO: LOOP UNTIL INKEY$ <> ""
        END
END IF
Title$ = "Future Software Presents: Cobra!"
Title$ = Title$ + SPACE$(80 - LEN(Title$))
Future.Print 0, 0, Title$, 15, 4
IF IsMMX THEN SetMMX 1: Future.Print 0, 16, "MMX enabled", 255, 0 ELSE Future.Print 0, 16, "No MMX found...", 255, 0
Future.Print 0, 32, "Initializing EMS memory...", 255, 0
IF IsEMMInstalled% THEN
        Future.Print 0, 48, "Version", 255, 0
        Future.Print 56, 48, STR$(GetEMMVersion!), 255, 0
        Future.Print 80, 48, "found.", 255, 0
        Menu = AllExpMem(40000)
ELSE
        Future.Print 0, 48, "You must enable EMS. Please refer to the documentation!", 255, 0
        DO: LOOP UNTIL INKEY$ <> ""
        END
END IF
OpenScores
ShowMenu
END SUB

SUB ShowMenu
Future.Print 0, 80, "Press the number level you wish to play (1-9)", 255, 0
Future.Print 0, 96, "1 is very easy, 9 is very hard", 255, 0
DO: A$ = INKEY$
IF A$ <> "" THEN P = ASC(RIGHT$(A$, 1))

SELECT CASE P
CASE 27: ReSetScreen: END
CASE 49: Difficulty = 1: EXIT SUB
CASE 50: Difficulty = 2: EXIT SUB
CASE 51: Difficulty = 3: EXIT SUB
CASE 52: Difficulty = 4: EXIT SUB
CASE 53: Difficulty = 5: EXIT SUB
CASE 54: Difficulty = 6: EXIT SUB
CASE 55: Difficulty = 7: EXIT SUB
CASE 56: Difficulty = 8: EXIT SUB
CASE 57: Difficulty = 9: EXIT SUB
CASE ELSE: BEEP
END SELECT
LOOP
END SUB

SUB ShowScore
SetViewPort 0, 0, 640, 480
Points$ = LTRIM$(RTRIM$(STR$(Score)))
Future.Print 635 - (LEN(Points$) * 8), 26, Points$, 255, 0
SetViewPort 15, 15, 539, 450
END SUB

